---
title: Performance
slug: Web/API/Performance
tags:
  - API
  - Interface
  - Navigation Timing
  - Performance
  - Reference
  - Web Performance
---
<div>{{APIRef("High Resolution Time")}}</div>

<p>The <strong><code>Performance</code></strong> interface provides access to performance-related information for the current page. It's part of the High Resolution Time API, but is enhanced by the <a href="/en-US/docs/Web/API/Performance_Timeline">Performance Timeline API</a>, the <a href="/en-US/docs/Web/API/Navigation_timing_API">Navigation Timing API</a>, the <a href="/en-US/docs/Web/API/User_Timing_API">User Timing API</a>, and the <a href="/en-US/docs/Web/API/Resource_Timing_API">Resource Timing API</a>.</p>

<p>An object of this type can be obtained by calling the {{domxref("window.performance")}} read-only attribute.</p>

<div class="note">
<p><strong><em>Note</em>: </strong>This interface and its members are available in <a href="/en-US/docs/Web/API/Web_Workers_API">Web Workers</a> via <code><a href="/en-US/docs/Web/API/WorkerGlobalScope/performance">WorkerGlobalScope.performance</a></code> , except where indicated below. Also, note that performance markers and measures are per context. If you create a mark on the main thread (or other worker), you cannot see it in a worker thread, and vice versa.</p>
</div>

<h2 id="Properties">Properties</h2>

<p><em>The <code>Performance</code> interface doesn't inherit any properties.</em></p>

<dl>
 <dt>{{domxref("Performance.navigation")}} {{readonlyInline}} {{deprecated_inline}}</dt>
 <dd>A legacy {{domxref("PerformanceNavigation")}} object that provides useful context about the operations included in the times listed in <code>timing</code>, including whether the page was a load or a refresh, how many redirections occurred, and so forth.
 <div class="notecard note">
 <p>Not available in workers.</p>
 </div>
 </dd>
 <dt>{{domxref("Performance.timing")}} {{readonlyInline}} {{deprecated_inline}}</dt>
 <dd>A legacy {{domxref("PerformanceTiming")}} object containing latency-related performance information.
 <div class="notecard note">
 <p>Not available in workers.</p>
 </div>
 </dd>
 <dt>{{domxref("Performance.memory")}} {{readonlyInline}} {{Non-standard_inline}}</dt>
 <dd>A <em>non-standard</em> extension added in Chrome, this property provides an object with basic memory usage information. <em>You <strong>should not use</strong> this non-standard API.</em></dd>
 <dt>{{domxref("Performance.timeOrigin")}} {{readonlyInline}} {{Non-standard_inline}}</dt>
 <dd>Returns the high resolution timestamp of the start time of the performance measurement.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<p><em><em>The <code>Performance</code> interface doesn't inherit any </em>methods</em>.</p>

<dl>
 <dt>{{domxref("Performance.clearMarks()")}}</dt>
 <dd>Removes the given <em>mark</em> from the browser's performance entry buffer.</dd>
 <dt>{{domxref("Performance.clearMeasures()")}}</dt>
 <dd>Removes the given <em>measure</em> from the browser's performance entry buffer.</dd>
 <dt>{{domxref("Performance.clearResourceTimings()")}}</dt>
 <dd>Removes all {{domxref("PerformanceEntry","performance entries")}} with a {{domxref("PerformanceEntry.entryType","entryType")}} of "<code>resource</code>" from the browser's performance data buffer.</dd>
 <dt>{{domxref("Performance.getEntries()")}}</dt>
 <dd>Returns a list of {{domxref("PerformanceEntry")}} objects based on the given <em>filter</em>.</dd>
 <dt>{{domxref("Performance.getEntriesByName()")}}</dt>
 <dd>Returns a list of {{domxref("PerformanceEntry")}} objects based on the given <em>name</em> and <em>entry type</em>.</dd>
 <dt>{{domxref("Performance.getEntriesByType()")}}</dt>
 <dd>Returns a list of {{domxref("PerformanceEntry")}} objects of the given <em>entry type</em>.</dd>
 <dt>{{domxref("Performance.mark()")}}</dt>
 <dd>Creates a {{domxref("DOMHighResTimeStamp","timestamp")}} in the browser's <em>performance entry buffer</em> with the given name.</dd>
 <dt>{{domxref("Performance.measure()")}}</dt>
 <dd>Creates a named {{domxref("DOMHighResTimeStamp","timestamp")}} in the browser's performance entry buffer between two specified marks (known as the <em>start mark</em> and <em>end mark</em>, respectively).</dd>
 <dt>{{domxref("Performance.now()")}}</dt>
 <dd>Returns a {{domxref("DOMHighResTimeStamp")}} representing the number of milliseconds elapsed since a reference instant.</dd>
 <dt>{{domxref("Performance.setResourceTimingBufferSize()")}}</dt>
 <dd>Sets the browser's resource timing buffer size to the specified number of "<code>resource</code>" {{domxref("PerformanceEntry.entryType","type")}} {{domxref("PerformanceEntry","performance entry")}} objects.</dd>
 <dt>{{domxref("Performance.toJSON()")}}</dt>
 <dd>Is a jsonizer returning a json object representing the <code>Performance</code> object.</dd>
</dl>

<h2 id="Events">Events</h2>

<p>Listen to these events using <code>addEventListener()</code> or by assigning an event listener to the <code>on<em>eventname</em></code> property of this interface.</p>

<dl>
 <dt>{{DOMxRef("Performance.resourcetimingbufferfull_event", "resourcetimingbufferfull")}}</dt>
 <dd>Fired when the browser's<a href="/en-US/docs/Web/API/Performance/setResourceTimingBufferSize"> resource timing buffer</a> is full.<br>
 Also available via the {{DOMxRef("Performance.onresourcetimingbufferfull", "onresourcetimingbufferfull")}} property.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Highres Time Level 2', '#sec-performance', 'Performance')}}</td>
   <td>{{Spec2('Highres Time Level 2')}}</td>
   <td>Defines <code>toJson()</code> method.</td>
  </tr>
  <tr>
   <td>{{SpecName('Highres Time', '#performance', 'Performance')}}</td>
   <td>{{Spec2('Highres Time')}}</td>
   <td>Defines <code>now()</code> method.</td>
  </tr>
  <tr>
   <td>{{SpecName('Performance Timeline Level 2', '#extensions-to-the-performance-interface', 'Performance extensions')}}</td>
   <td>{{Spec2('Performance Timeline Level 2')}}</td>
   <td>Changes <code>getEntries()</code> interface.</td>
  </tr>
  <tr>
   <td>{{SpecName('Performance Timeline', '#extensions-to-the-performance-interface', 'Performance extensions')}}</td>
   <td>{{Spec2('Performance Timeline')}}</td>
   <td>Defines <code>getEntries()</code>, <code>getEntriesByType()</code> and <code>getEntriesByName()</code> methods.</td>
  </tr>
  <tr>
   <td>{{SpecName('Resource Timing', '#extensions-performance-interface', 'Performance extensions')}}</td>
   <td>{{Spec2('Resource Timing')}}</td>
   <td>Defines <code>clearResourceTimings()</code> and <code>setResourceTimingBufferSize()</code> methods and the <code>onresourcetimingbufferfull</code> property.</td>
  </tr>
  <tr>
   <td>{{SpecName('User Timing Level 2', '#extensions-performance-interface', 'Performance extensions')}}</td>
   <td>{{Spec2('User Timing Level 2')}}</td>
   <td>Clarifies <code>mark()</code>, <code>clearMark()</code>, <code>measure()</code> and <code>clearMeasure()</code> methods.</td>
  </tr>
  <tr>
   <td>{{SpecName('User Timing', '#extensions-performance-interface', 'Performance extensions')}}</td>
   <td>{{Spec2('User Timing')}}</td>
   <td>Defines <code>mark()</code>, <code>clearMark()</code>, <code>measure()</code> and <code>clearMeasure()</code> methods.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.Performance")}}</p>
</div>
